#define    TRUE    (!FALSE)
#define    FALSE   0
#define    BYTE    unsigned char
#define    WORD    unsigned short int
#define    BOOLEAN char

#define TIMER_OVF_ENOUGHT   49
#define NO_PULSES_INTERVAL  200 

#define LED_delay 250    
#define Light_delay 2500
//#define Anode
#define Cathode        

#define     CNT_100_MS  6250

#define byBladeCnt 2 //1-  , 2 -  , 4 - ...
#define Prescaler 0x01 //0x00 -   4MHz, 0x01 -   8MHz...
#define UpCount 4  // +1 =   (0,1S)  

#include    <tiny2313.h>
#include    <delay.h>                               


BOOLEAN btTimeUpdate;   // = 1,      
WORD wTime;             // ,    (  )

BOOLEAN btTimerOn;      // TRUE -  , FALSE - 

BYTE    byTcnt;         //   

BYTE    byDisplayRefreshCnt;    // 

void ShowDisplayData(void);     //   
void PrepareRpmData(WORD wRpm);

BOOLEAN btDisplayUpdate;        // = TRUE,     


BYTE byDisplay[4];        //  ,           
WORD    wLockedRpm;

//  
BYTE byCharacter[12] = {0xFA,     //0
                0x82,   //1
 	        0xB9,   //2
	        0xAB,	//3 
	        0xC3,     //4 
	        0x6B,     //5 
	        0x7B,     //6
                0xA2,    //7 
                0xFB,      //8
                0xEB,      //9 
                0x00,      //blank   
                0x01     //-
                }; 

WORD    wRpm;           //    (/)

//BOOLEAN btRpmUpdate;    // = 1,     

WORD    wTimerOvfCnt;   //    ( 
                        //  

WORD    wFlashCnt;      //     

BOOLEAN btFirstLowRateFlash;    // FALSE -      
                                // (    )    
                                                                    

/************************************************************************\
   .
      :  -
      : -
\************************************************************************/
void RefreshDisplay(void)
{                                
    #asm("cli");
    if (btDisplayUpdate)
    {
      wLockedRpm = wRpm;
      btDisplayUpdate = FALSE;
    }
    #asm("sei");
    
    PrepareRpmData(wLockedRpm);
    ShowDisplayData();
}

/************************************************************************\
       
     
      :  wRpm -  , byBladeCnt -  
      : -
\************************************************************************/
void PrepareRpmData(WORD wRpm)
{
    BYTE i;
    WORD R;
    
    R = wRpm;       
    
    byDisplay[3] = wRpm % 10;
    wRpm /= 10;
              
    if (byDisplay[3] > 4)  //
    {
      wRpm++;
      R += 10;
    }        
    
    byDisplay[3] = 0;
    
    
    //  4  -  
    for(i=0; i<3; i++)
    {
       byDisplay[2-i] = wRpm % 10;
       wRpm /= 10;
    }
    
    if (R < 10)
    {
      byDisplay[0] = 10;
      byDisplay[1] = 10;
      byDisplay[2] = 10;            
      goto exit;
    }   
    if ((R >= 10) & (R <100))
    {
      byDisplay[0] = 10;
      byDisplay[1] = 10;
      goto exit;
    }
    if ((R >= 100) & (R <1000))
    {
      byDisplay[0] = 10;
      goto exit;
    }            
    
    
                    
exit:
}


/************************************************************************\
      .
      :  -
      : -
\************************************************************************/
void ShowDisplayData(void)
{
#ifdef Cathode
  PORTB = byCharacter[byDisplay[0]];
  PORTD.5 = 0;
  delay_us(LED_delay);
  PORTD.5 = 1;    
     
  PORTB = byCharacter[byDisplay[1]];
  PORTD.1 = 0;
  delay_us(LED_delay);
  PORTD.1 = 1;
      
  PORTB = byCharacter[byDisplay[2]];
  PORTD.0 = 0;
  delay_us(LED_delay);
  PORTD.0 = 1;
      
  PORTB = byCharacter[byDisplay[3]];
  PORTD.4 = 0;
  delay_us(LED_delay);
  PORTD.4 = 1;
#endif

#ifdef Anode
  PORTB = ~byCharacter[byDisplay[0]];
  PORTD.5 = 1;
  delay_us(LED_delay);
  PORTD.5 = 0;    
     
  PORTB = ~byCharacter[byDisplay[1]];
  PORTD.1 = 1;
  delay_us(LED_delay);
  PORTD.1 = 0;
      
  PORTB = ~byCharacter[byDisplay[2]];
  PORTD.0 = 1;
  delay_us(LED_delay);
  PORTD.0 = 0;
      
  PORTB = ~byCharacter[byDisplay[3]];
  PORTD.4 = 1;
  delay_us(LED_delay);
  PORTD.4 = 0;
#endif
  
  if (! PIND.6)
  {     
    delay_us(Light_delay); 
  }
}                                
                                
/**************************************************************************\
      OC1 (   0.1 )
      :  -
      : -
\**************************************************************************/
interrupt [TIM1_COMPA] void SYSTEM_TICK_interrupt(void)
{
    //     
    OCR1A += CNT_100_MS;

    // 3     ,
    //   .
    if( ++byDisplayRefreshCnt == UpCount )
    {
        byDisplayRefreshCnt = 0;
        btDisplayUpdate = TRUE;

    }
    //    -   
    if( btTimerOn )    
    {
        if (++byTcnt == 10)
        {
            byTcnt = 0;
            if( ++wTime == 60000)
                wTime = 0;
        }
    }


}
                                
/**************************************************************************\
        
      :  -
      : -
\**************************************************************************/
interrupt [EXT_INT0] void RPM_PULSE_interrupt(void)
{
    long lTmp;

    GIMSK &= ~0x40;

    if(btFirstLowRateFlash)
    {
        //  ,    
        //  
        wTimerOvfCnt = 0;
        wFlashCnt = 0;
        TCNT0 = 0;
        TIFR = 0x02;
        TCCR0B = 0x03;   // FCK / 64 ( 62.5 KHz )
        TCNT0 = 0;
        TIMSK |= 0x02;  //    TMR0

        btFirstLowRateFlash = FALSE;
    }
    else
    {
        wFlashCnt++;
        // ,     
        if( wTimerOvfCnt > TIMER_OVF_ENOUGHT )
        {
            TCCR0B = 0;      //  TMR0
            GIMSK &= 0x40;  //    INT0
            TIMSK &= ~0x02; //    TMR0
            if(TIFR & 0x02)
                wTimerOvfCnt++;    //   

            lTmp = (62500L * 60L * (long)wFlashCnt);
            lTmp /= ((wTimerOvfCnt << 8) + TCNT0);
            lTmp /= byBladeCnt;
            wRpm = lTmp;

            //  
            btFirstLowRateFlash = TRUE;

            wTimerOvfCnt = 0;
            TCNT0 = 0;
            TCCR0B = 0x03;   // FCK / 64 ( 62.5 KHz )
            TCNT0 = 0;
            TIFR = 0x02;
            TIMSK |= 0x02;  //    TMR0

//            GIFR = 0x40;

        }
    }
    EIFR = 0x40;
    GIMSK |= 0x40;
}

/**************************************************************************\
      TMR0 (    8 )
      :  -
      : -
\**************************************************************************/
interrupt [TIM0_OVF] void TIMER0_interrupt(void)
{
    wTimerOvfCnt++;

    //      ,  
    // 0     
    if( wTimerOvfCnt > NO_PULSES_INTERVAL )
    {
        wRpm = 0;
        btFirstLowRateFlash = TRUE;
        wTimerOvfCnt = 0;
    }
}                                
                                
/**************************************************************************\
     .   .   
    .
      :  -
      : -
\**************************************************************************/
void main(void)
{    
// Crystal Oscillator division factor:
#pragma optsize-
CLKPR=0x80;
CLKPR=Prescaler;        //0x00 -   4MHz, 0x01 -   8MHz...
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

    #asm("cli");
    
    MCUCR = 0x00;   //  SLEEP,     .
                    //  ,     .
    
    GIMSK = 0x00;   //   
    EIFR = 0xFF;    //   
    
    TIMSK = 0x00;   //    
    TIFR = 0xFF;    //   

        // DDRx -     (0 - , 1 - ).
        // PORTx -     (DDRx = 1), :
        //           1 -     . 1
        //           0 -     . 0
        //        (DDRx = 0),  PORTx -     ( PORTx = 1  )
        // PINx -          
        
        PORTA=0b00000011;
        DDRA= 0b00000011;           
        
        PORTB=0b00000000;
        DDRB= 0b11111111;
                 
      #ifdef Cathode  
        PORTD=0b01111111;
        DDRD= 0b00110011;
      #endif
      
      #ifdef Anode  
        PORTD=0b01001100;
        DDRD= 0b00110011;
      #endif
      
    //  
    //time------------------------------------
    btTimerOn = FALSE;
    wTime = 0;
    byTcnt = 0;
    byDisplayRefreshCnt = 0;
    
    btTimeUpdate = FALSE;
    
    TCNT1 = 0;
    
    TCCR1A = 0x00;      //    OC1  PWM

    TCCR1B = 0x03;      //    FCK    64,
                        //  ,   

    OCR1A = TCNT1 + CNT_100_MS;

    TIFR  |= 0x40;      //     Output-Compare
    TIMSK |= 0x40;      //    Output-Compare
    //time------------------------------------
    
    //rmp-------------------------------------
    btFirstLowRateFlash = TRUE;
    wRpm = 0;

    //   INT1
    EIFR = 0x40;
    GIMSK |= 0x40;
    MCUCR = 0x02;   //  INT0  ,    .
    
    //   ,  
    //  
    wTimerOvfCnt = 0;
    TCNT0 = 0;
    TCCR0B = 0x03;   // FCK / 64 ( 62.5 KHz )
    TCNT0 = 0;
    TIMSK |= 0x02;  //    TMR0
    //rmp-------------------------------------
    
    
    
    #asm("sei");

//    StartLowRateRpm();
    while(TRUE)
    {
       
            RefreshDisplay();

 
    }
}

